# -*- coding: utf-8 -*-
import sys
import hashlib
import re
import cookielib
import urllib2

SERIESPEPITO_REQUEST_HEADERS = {
    "User-Agent" : "Mozilla/5.0 (Windows NT 6.1; rv:28.0) Gecko/20100101 Firefox/28.0",
    "Accept-Language" : "es-ES,es;q=0.8,en-US;q=0.5,en;q=0.3",
    "Accept" : "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8",
    "Connection" : "keep-alive"
}

cookies = cookielib.LWPCookieJar()

# Captura el nombre de la Cookie del javascript de la página
# y saca su valor de las cookies de la respuesta HTTP
#
# Quizás no haga falta sacarla de la página porque solo hay 2 cookies
# y la correcta es la que no se llama visita
#
def get_cookie(html):
    cookie_value = ''

    cookie_pat = "cookie\('([a-zA-Z0-9]+)'\);"
    cookie_name = find_single_match(html, cookie_pat)

    for cookie in cookies:
        if cookie.name == cookie_name:
            cookie_value = cookie.value
            break

    return cookie_value

# Busca el enlace correcto y lo procesa capturando los caracteres
# y posiciones del Javascript
#
def get_link(html):
    hash_seed = get_cookie(html);

    hash = hashlib.sha256(hash_seed).hexdigest()

    HREF_SEARCH_PAT = '<a class=".' + hash + '" target="_blank" href="http://www.enlacespepito.com\/([^\.]*).html"><i class="icon-play">'

    href = list(find_single_match(html, HREF_SEARCH_PAT))

    CHAR_REPLACE_PAT = '[a-z]\[(\d+)\]="(.)";'

    matches = re.findall(CHAR_REPLACE_PAT , html, flags=re.DOTALL|re.IGNORECASE)
    for match in matches:
        href[int(match[0])] = match[1]

    href = ''.join(href)

    return 'http://www.enlacespepito.com/' + href + '.html'



# Esta función se usa en pelisalacarta
#
def find_single_match(data,patron,index=0):
    try:
        matches = re.findall( patron , data , flags=re.DOTALL )
        return matches[index]
    except:
        return ""


# funciones HTTP
#
class NoRedirection(urllib2.HTTPErrorProcessor):
    def http_response(self, request, response):
        return response
    https_response = http_response

handlers = [
    urllib2.HTTPCookieProcessor(cookies),
    NoRedirection
]
opener = urllib2.build_opener(*handlers)

def fetch_page(uri):
    req = urllib2.Request(uri, None, SERIESPEPITO_REQUEST_HEADERS)
    response = opener.open(req)
    return response.read()

def fetch_location(uri):
    req = urllib2.Request(uri, None, SERIESPEPITO_REQUEST_HEADERS)
    return opener.open(req).info().getheader('Location')


def main():
    enlace_inicial = sys.argv[1]

    html = fetch_page(enlace_inicial)

    enlace_arreglado = get_link(html)

    # Sin el Referer da 404
    SERIESPEPITO_REQUEST_HEADERS['Referer'] = enlace_inicial

    print fetch_location(enlace_arreglado)


if __name__ == "__main__":
    main()
